<?php
/*
Plugin Name:  BBCode ADV2
Version: 0.8
Plugin URI: http://flatpress.info/
Description:  BBCode Advance 2
Author: Flatpress.info
Author URI: http://flatpress.info
*/

function plugin_onoff(){ 
    global $fp_config;
    global $smarty;
    global $bbcodeAdv2Flag;
    if ($fp_config['plugins']['bbcodeAdv2']['shape'] == "ON") {
        $bbcodeAdv2Flag = 1;    
    } else {
        $bbcodeAdv2Flag = 0;    
    }
}


if (class_exists('AdminPanelAction')) {
  class admin_plugin_bbcodeAdv2 extends AdminPanelAction {
    function setup() {
      $this->smarty->assign('admin_resource', "plugin:bbcodeAdv2/admin.plugin.bbcodeAdv2");
      $ba_config = plugin_getoptions('bbcodeAdv2');
      if(!$ba_config['shape']) {
        $shape = "OFF";
        plugin_addoption('bbcodeAdv2', 'shape', $shape);
        plugin_saveoptions('bbcodeAdv2');
      }
      if(!$ba_config['cats']) {
        $cats = "Set Journal Number";
        plugin_addoption('bbcodeAdv2', 'cats', $cats);
        plugin_saveoptions('bbcodeAdv2');
      }
    }
    function main() {
      $ba_config = plugin_getoptions('bbcodeAdv2');
      $this->smarty->assign('ba_config', $ba_config);
    }
    function onsubmit() {
      $sflag = 0;
      if ($_POST['ba-shape']){
        $shape = $_POST['ba-shape'];
        plugin_addoption('bbcodeAdv2', 'shape', $shape);
        plugin_saveoptions('bbcodeAdv2');
        $this->smarty->assign('success', 1);
        $sflag++;
      }
      if ($_POST['ba-cats']){
        $cats = $_POST['ba-cats'];
        plugin_addoption('bbcodeAdv2', 'cats', $cats);
        plugin_saveoptions('bbcodeAdv2');
        $this->smarty->assign('success', 1);
        $sflag++;
      } 
      if ($sflag != 2) {
        $this->smarty->assign('success', -1);
      }
      return 2;
    }
  }
 }
admin_addpanelaction('plugin', 'bbcodeAdv2', true);

function plugin_todaytitle_btn() {
  global $smarty;
  global $bbcodeAdv2Flag;
  plugin_onoff();
  $c = <<<_EOT_
    <style>
    input#subject {
    width: 600px;
    }
    input#todaytitle_btn {
    position: absolute;
    top: 132px;
    left: 540px;
    }
    input#todayclear_btn {
    position: absolute;
    top: 132px;
    left: 590px;
    }
</style>
_EOT_;
echo $c;
$act = "<INPUT id=\"todaytitle_btn\" type=\"button\" value=\"Today\" onClick=\"setSubj();\">";
if($bbcodeAdv2Flag)
  echo $act;
      $bb_config = plugin_getoptions('bbcodeAdv2');
      $catset = $bb_config['cats'];
$act = "<INPUT id=\"todayclear_btn\" type=\"button\" value=\"CLR\" onClick=\"clrSubj();\">";
if($bbcodeAdv2Flag)
  echo $act;
$js = <<<_EOT_
<script>
var dd = function(num) {
  num += "";
  if (num.length === 1) {
    num = "0" + num; 
  }
  return num;
};

function setSubj() {
  var wd = new Array("Sun","Mon","Tue","Wed","Thu","Fri","Sat");
  var today = new Date();
  var td = today.getFullYear() + "-" + dd((today.getMonth()+1)) + "-" + dd(today.getDate()) + "," + wd[today.getDay()];
  document.getElementById('subject').value=td;
  var catset = "$catset";
  document.forms["admin_entry_write"].elements[catset].checked = true;
}

function clrSubj() {
  document.getElementById('subject').value="";
  var catset = "$catset";
  document.forms["admin_entry_write"].elements[catset].checked = false;
}

</script>
_EOT_;
echo $js;
}
//add_filter('simple_edit_form', 'plugin_todaytitle_btn');
add_action('simple_edit_form', 'plugin_todaytitle_btn');


////////////////////////////////////////////////////////////////////////////////////////////
//  カレンダー表示
//  $YM yyyy-mm(ex.'2015-04')
////////////////////////////////////////////////////////////////////////////////////////////
function makeCalender($YM){
  global $wday;
  global $atrbJ;
  $wday = array('S','M','T','W','T','F','S');

  //引数チェック
  if($YM == ''){
    $YM = date('Y-m');
  }else{
    if(preg_match('/\d{4}\-\d{2}/',$YM) === false){
      return '年月不正';
    }
  }
  $y = substr($YM,0,4);
  $m = substr($YM,5,2);
  if(!checkdate($m,1,$y)){
    return '年月不正';
  }

  //指定月の１日の曜日を取得
  $wd1   = date('w', mktime(0,0,0,$m,1,$y));
  //月末の日を取得
  $lastd = date('d', mktime(0,0,0,$m+1,0,$y));

  $calD = $YM;
 
  $calP = "admin.php?p=entry&action=write&cal=P" . "&calD=" . $calD;
  $calN = "admin.php?p=entry&action=write&cal=N" . "&calD=" . $calD;

  //カレンダー出力ヘッダ部
  $calender  = '<div id=calender>';
  $calender .= '<table class=\'cal\' border=\'1\' cellpadding=\'0\' cellspacing=\'0\' style=\'text-align:center;\'>';
  $calender .= '<tr class=\'caltop\'>';
  $calender .= "<td class=caltd><a href=$calN>＜</a></td>";
  $calender .= '<td class=\'caltd\' colspan=\'5\'>'.sprintf('%4d/%02d',$y,$m).'</td>';
  $calender .= "<td class=caltd><a href=$calP>＞</a></td>";
  $calender .= '</tr>';
  $calender .= '<tr class=\'cal\'>';
  $calender .= '<td class=\'caltdSUN\'>'.$wday[0].'</td>';
  $calender .= '<td class=\'caltd\'>'.$wday[1].'</td>';
  $calender .= '<td class=\'caltd\'>'.$wday[2].'</td>';
  $calender .= '<td class=\'caltd\'>'.$wday[3].'</td>';
  $calender .= '<td class=\'caltd\'>'.$wday[4].'</td>';
  $calender .= '<td class=\'caltd\'>'.$wday[5].'</td>';
  $calender .= '<td class=\'caltdSAT\'>'.$wday[6].'</td>';
  $calender .= '</tr>';

        $arrayFiles = array();
        $arrayJournal = array();
        $yy = substr($y, 2, 3);
        $sub = "SUBJECT|";
        $DIR = CONTENT_DIR;

        if ($dir = opendir("$DIR$yy/$m/")) {

          while (($file = readdir($dir)) !== false) {
            if ($file != "." && $file != "..") {
              array_push($arrayFiles, $file);
              // grep SUBJECT in File

              $fp = fopen("$DIR$yy/$m/$file", 'r');
              if ($fp){
                if (flock($fp, LOCK_SH)){
                  while (!feof($fp)) {
                    $buffer = fgets($fp);
                    if ($sub_pos = strpos($buffer, $sub)) {
                      //                      echo substr($buffer, $sub_pos + 8, 10). "<br>";
                      $journal_match = preg_match('/[0-9]{4}-[0-9]{2}-[0-9]{2}/', substr($buffer, $sub_pos + 8, 10), $journaldate);
                      //                      $journaldate = preg_replace("/\r\n|\r|\n/", "", $journaldate); 
                      if ($journal_match)
                        array_push($arrayJournal, $journaldate[0]);
                    }
                  }
                  flock($fp, LOCK_UN); 
                } else {
                  echo "filelock feiled."; 
                } 
              }
            }
          }
          closedir($dir); 
        }
        ///        print_r($arrayFiles);

  //カレンダー出力日付部
  for($i = 0; $i <= 5; $i++){
    if($d >= $lastd){
      break;
    }
    $calender .= '<tr class=\'cal\'>';
    for($j = 0; $j <= 6; $j++) {
      $d = ($i * 7) + ($j - $wd1) + 1;
      if ($d > $lastd or $d  < 1) {
        $calender .= '<td class=\'caltdNull\'>  </td>';
      }else{
        $entryTdate = $y . "-" . $m . "-" . sprintf('%02d', $d) ;
        $atrbJ = '<span style=\'color: #aaa;\'>';
        foreach ($arrayJournal as $val) {
          if ($entryTdate === $val) {
            $journal_val = 1;
            $atrbJ = '<span style=\'color: #00aa00;\'>';
            break;
          } 
        }

        if(sprintf('%4d%02d%02d',$y,$m,$d) == date('Ymd')){
          //現在の月日に一致した時
          $dval = date('Ymd');
          if($journal_val != 1) {
            $calender .= '<td class=\'caltd-today_done\'>'.sprint_date($y, $m, $d).'</td>';
          } else {
            $calender .= '<td class=\'caltd-today\'>'.sprint_date($y, $m, $d).'</td>';
          }
        }else{
          switch($j){
            case 0: //日曜日
              $calender .= '<td class=\'caltdsun\'>'.sprint_date($y, $m, $d).'</td>';
              break;
            case 6: //土曜日
              $calender .= '<td class=\'caltdsat\'>'.sprint_date($y, $m, $d).'</td>';
              break;
            default: //平日
              $calender .= '<td class=\'caltd\'>'.sprint_date($y, $m, $d).'</td>';
          }
        }
      }
    }
    $calender .= '</tr>';
  }
  $calender .= '</table></div>';
  // print $calender;

  return cal_header(). $calender;
}



function sprint_date($y, $m, $d) {
  global $atrbJ;
  // $specify_url = BLOG_BASEURL . "admin.php?p=entry&action=write&specified=" . "$y-$m-" . sprintf('%02d',$d);
  // return "<a href=\"$specify_url\">" . sprintf('%2d',$d) . "</a>";
  $d = sprintf('%02d',$d);
  $sub = "$y-$m-$d";
  $key = "|SUBJECT|" . $sub;
  $ret = rtrim(find_subject_whole($key), ".txt");
  $emret = "";
  for($i = 0; $i < strlen($ret); $i++) {
    if ($i > 6 && $i < 11) {
      $emret .= "<span class=emdate>" . $ret[$i] . "</span>";
    } else {
      $emret .= "$ret[$i]";
    }
  } 

  /* http://flatpress.world/admin.php?p=entry&action=write&entry=entry150209-044724 */
  $specify_url = BLOG_BASEURL . "admin.php?p=entry&action=write&entry=" . $ret;
  return "<a href=\"$specify_url\">" . $atrbJ . sprintf('%2d',$d) . "</span></a>";
}


function find_subject_whole($keyword){
  /* VERSION|fp-1.0.2|SUBJECT|2015-02-08,Sun|CONTENT|.... */
  $contentdir = getcwd() . "/fp-content/content/";
  $root = realpath($contentdir) . "/" ;
  $files = list_files($root);
  foreach ($files as $key => $value) {
    $result = find_subject($value, $keyword);
    if(is_string($result))
      return basename($value);
  }
  return $ret;
}

function list_files($dir){
  $files = array();
  $list = scandir($dir);
  foreach($list as $file){
    if($file == '.' || $file == '..'){
      continue;
    } else if (is_file($dir . $file)){
      $files[] = $dir . $file;
    } else if( is_dir($dir . $file) ) {
      $files = array_merge($files, list_files($dir . $file . '/'));
    }
  }
  return $files;
}

function find_subject($filename, $keyword) {
  /*
   * key match        filename
   * key not match    0
   * file not found  -1
   */
  $ret = 0;
  $len = strlen($keyword); 
  if(is_file($filename)) { 
    $text = fopen($filename, 'r'); 
    while(!feof($text)) { 
      $lines = fgets($text); 
      if(strpos($lines, $keyword) !== false){
        $name = basename($filename);
        $ret = $name; 
      }
    }
    fclose($text); 
    return($ret);
  }else { 
    $ret = -1;
    return($ret);
  }
}


function cal_header() {
$cal_header = <<< _HEADER_

<style type='text/css'>

#calender td {
  background-color: #fdfdfd;
}
#calender .cal {
  font-size:10pt; border-collapse:collapse;
  border-color: #ddd;
}

#calender .caltdNull {
  background-color: #e8e8e8;
  border-color: #eee;
}


#calender .caltop {
  border-color: #ddd;
  background-color: #eee;
}

#calender .caltdSUN {
  border-color: #ddd;
  background-color: #fdd;
  color: #F00;
}

#calender .caltdSAT {
  border-color: #ddd;
  background-color: #ddf;
  color: #00F;
}

#calender .caltdsun {
  border-color: #ddd;
  background-color: #fee;
}

#calender .caltdsat {
  border-color: #ddd;
}

#calender .caltd {
  border-color: #ddd;
}

#calender .caltd-today_normal {
  border-color: #ddd;
}

#calender .caltd-today {
  border-color: #ddd;
  background-color:#CCCCFF;
  background-color: #afa;
  border-bottom: 2px solid red;
}

#calender .red {
  background-color:#FFCCCC;
}

#calender .blue {
  background-color:#CCCCFF;
}

#calender .head {
  background-color:#CCFFCC;
}

#calender a:hover {
  background-color:#FFFF00;
  color:#000099;
  text-decoration: none;
}
#calender a {
  text-decoration: none;
}
</style>
_HEADER_;
       return $cal_header;
}


function plugin_bbcodeAdv2_main(){ 
    global $bbcodeAdv2Flag;
    plugin_onoff();
    if ($bbcodeAdv2Flag){
        $date = $_GET['calD'];
        if($date == "") { 
            $date = date('Y-m');
        }
        $pdate = '';
        if($_GET['cal'] == 'P'){
            $pdate = date('Y-m',mktime(0,0,0,substr($date,5,2)+1,1,substr($date,0,4)));
        } elseif ($_GET['cal'] == 'N'){ 
            $pdate = date('Y-m',mktime(0,0,0,substr($date,5,2)-1,1,substr($date,0,4)));
        } 
        $r = makeCalender($pdate);
        echo "<div style=\"position: absolute;  right: 10px; top: 124px;\">";
        echo $r;
        echo "</div>";
    }
}
add_filter('simple_edit_form', plugin_bbcodeAdv2_main);

?>
